<template>
  <!-- 基础页面 -->
  <div class="app-container">
    <el-form v-show="showSearch" :model="queryParams" ref="queryForm" size="small" inline>
      <el-form-item label="申请日期" prop="startTime">
        <el-date-picker
          v-model="queryParams.startTime"
          value-format="yyyy-MM-dd"
          type="date"
          placeholder="开始日期"
          @change="() => queryParams.endTime = ''"
          style="width: 130px"
        />
      </el-form-item>
      <el-form-item>-</el-form-item>
      <el-form-item prop="endTime">
        <el-date-picker
          v-model="queryParams.endTime"
          value-format="yyyy-MM-dd"
          type="date"
          placeholder="结束日期"
          :picker-options="{ disabledDate: (t) => t.getTime() < new Date(queryParams.startTime).getTime() - 86400000}"
          style="width: 130px"
        />
      </el-form-item>
      <el-form-item label="关键字" prop="keyWord">
        <el-input
          v-model="queryParams.keyWord"
          placeholder="请输入关键字"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="审核状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="请选择审核状态" clearable>
          <el-option v-for="item in statusOptions" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>

      <!-- 表单按钮 -->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">查询</el-button>
        <el-button icon="el-icon-refresh" @click="handleReset">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!-- <el-col :span="1.5" v-hasPermi="['direct:info:add']">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd">直转申请</el-button>
      </el-col> -->
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport">导出数据</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table :data="tableList" fit highlight-current-row style="width: 100%" :max-height="650" v-loading="loading">
      <!-- 多选 -->
      <el-table-column type="selection" width="55" align="center" @selection-change="selectionChange" />
      <el-table-column
        type="index"
        width="55"
        label="序号"
        align="center"
        :index="indexContinuation(queryParams.pageNum, queryParams.pageSize)"
      />
      <el-table-column
        v-for="(column, index) in tableColumns"
        :show-overflow-tooltip="column.showTooltip"
        :key="column.prop"
        :label="column.label"
        :prop="column.prop"
        :width="column.width"
        align="center"
      >
        <!-- 插槽 -->
        <template v-slot="scope" v-if="column.prop == 'status'">
          <el-tag v-if="scope.row.status == '0'" type="warning" size="mini" style="margin-right: 5px">待审核</el-tag>
          <el-tag v-else-if="scope.row.status == '1'" size="mini" style="margin-right: 5px">审核中</el-tag>
          <el-tag v-else-if="scope.row.status == '2'" type="success" size="mini" style="margin-right: 5px">
            已完成
          </el-tag>
          <el-tag v-else-if="scope.row.status == '3'" type="danger" size="mini" style="margin-right: 5px">
            已驳回
          </el-tag>
        </template>
      </el-table-column>
      <!-- 操作 -->
      <el-table-column label="操作" align="center" width="180">
        <template slot-scope="scope">
          <el-button type="text" size="mini" icon="el-icon-search" @click="handleEdit(scope.row, 1)">查看</el-button>
          <el-button
            v-show="scope.row.status == '0' ||scope.row.status == '3'"
            v-hasPermi="['direct:info:edit']"
            type="text"
            size="mini"
            icon="el-icon-edit"
            @click="handleEdit(scope.row, 2)"
          >
            编辑
          </el-button>
          <el-button
            v-show="scope.row.status == '0' ||scope.row.status == '3'"
            v-hasPermi="['direct:info:delete']"
            type="text"
            size="mini"
            icon="el-icon-delete"
            style="color: #f56c6c"
            @click="handleDelete(scope.row)"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页 -->
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
  </div>
</template>

<script>
import { getLoseAuditListApi, receiveLoseDelete } from '@/api/business/index'

export default {
  name: 'LoseHandlingRecord',
  data() {
    return {
      loading: false,
      showSearch: true,
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        keyWord: '', // 关键字
        status: '', // 审核状态
        timeRange: [], // 日期范围
        startTime: '', // 开始日期
        endTime: '' // 结束日期
      },
      // 考勤状态
      statusOptions: [
        { label: '待审核', value: '0' },
        { label: '审核中', value: '1' },
        { label: '已完成', value: '2' },
        { label: '已驳回', value: '3' }
      ],
      total: 0, // 总条数
      // 表头
      tableColumns: [
        { label: '申请时间', prop: 'createTime', showToolTip: true, width: '100' },
        { label: '申请人', prop: 'createBy', showToolTip: true,  },
        { label: '报备丢失单号', prop: 'code', showToolTip: true },
        { label: '报备丢失单位', prop: 'lossUnitName', showToolTip: false },
        { label: '报备丢失工程', prop: 'lossProName', showToolTip: false },
        { label: '物资类型', prop: 'typeName', showToolTip: true },
        { label: '状态', prop: 'status', showToolTip: true, width: '80' }
      ],
      // 表格数据
      tableList: []
    }
  },
  created() {
    this.getList()
  },
  methods: {
    // 查询
    handleQuery() {
      this.getList()
    },
    // 重置
    handleReset() {
      this.queryParams.pageNum = 1
      this.queryParams.pageSize = 10
      this.$refs.queryForm.resetFields()
      this.getList()
    },
    // 获取列表
    async getList() {
      console.log('列表-查询', this.queryParams)
      try {
        this.loading = true
        const params = {
          ...this.queryParams,
          // startTime: this.queryParams.timeRange[0] || '',
          // endTime: this.queryParams.timeRange[1] || ''
        }
        const res = await getLoseAuditListApi(params)
        console.log('🚀 ~ 获取列表 ~ res:', res)
        this.tableList = res.data.rows
        this.total = res.data.total || 0
      } catch (error) {
        console.log('🚀 ~ 获取列表 ~ error:', error)
        this.tableList = []
        this.total = 0
      } finally {
        this.loading = false
      }
    },
    // 多选
    selectionChange(val) {
      console.log('selectionChange', val)
    },
    handleAdd() {
      console.log('报备丢失申请')
      this.$router.push({ path: '/business/loseHandling/index' })
    },
    // 编辑
    handleEdit(row, type) {
      console.log('编辑', row)
      let params = {}
      if (type === 1) {
        // params = { type: 'detail', id: row.id }
        // this.$router.push({ path: '/transition/groundDirect', query: params })
        this.$router.push({
          name: 'lose-apply',
          query: {
            id: row.id,
            flowId: row.flowId,
            taskId: row.id,
            type: 'detail',
            nodeId: row.nodeId
          }
        })
      } else {
        params = { type: 'edit', id: row.id }
        this.$router.push({ path: '/business/businessHandling/loseHandling', query: params })
      }
    },
    // 删除
    handleDelete(row) {
      console.log('删除', row)
      this.$confirm('是否删除该数据?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        const res = await receiveLoseDelete({id:row.id})
        console.log('🚀 ~ 删除 ~ res:', res)
        this.getList()
        this.$message({
          type: 'success',
          message: '删除成功!'
        })
      })
    },
    // 导出数据
    handleExport() {
      try {
        const formatTime = date => {
          const year = date.getFullYear()
          const month = String(date.getMonth() + 1).padStart(2, '0')
          const day = String(date.getDate()).padStart(2, '0')
          const hours = String(date.getHours()).padStart(2, '0')
          const minutes = String(date.getMinutes()).padStart(2, '0')
          const seconds = String(date.getSeconds()).padStart(2, '0')
          return `${year}${month}${day}_${hours}${minutes}${seconds}`
        }

        const currentTime = formatTime(new Date())
        let fileName = `报备丢失记录_${currentTime}.xLsx`
        let url = '/material/LossAssign/export'
        const params = { ...this.queryParams }
        console.log('🚀 ~ 导出 ~ params:', params)
        this.download(url, params, fileName)
      } catch (error) {
        console.log('导出数据失败', error)
      }
    }
  }
}
</script>

<style lang="scss" scoped></style>
